State persistence in EJ2 JavaScript Gantt control

29 Jul 202312 minutes to read

State persistence refers to the Gantt’s state maintained in the browser’s localStorage even if the browser is refreshed or if you move to the next page within the browser. State persistence stores gantt’s model object in the local storage when the enablePersistence is defined as true.

Get or set localStorage value

If the enablePersistence property is set to true, the gantt property value is saved in the window.localStorage for reference. You can get/set the localStorage value by using the getItem/setItem method in the window.localStorage.

//get the Gantt model.
let value: string = window.localStorage.getItem('ganttGantt'); //"ganttGantt" is component name + component id.
let model: Object = JSON.parse(model);
//set the Gantt model.
window.localStorage.setItem('ganttGantt', JSON.stringify(model)); //"ganttGantt" is component name + component id.

You can refer to our JavaScript Gantt feature tour page for its groundbreaking feature representations. You can also explore our JavaScript Gantt example to knows how to present and manipulate data.

Prevent columns from persisting

When the enablePersistence property is set to true, the Gantt properties such as Filtering, Sorting , and Columns will persist. You can use the addOnPersist method to prevent these Gantt properties from persisting.

The following example demonstrates how to prevent Gantt columns from persisting. In the dataBound event of the Gantt, you can override the addOnPersist method and remove the columns from the key list given for persistence.

Note: When the enablePersistence property is set to true, the Gantt features such as column template, column formatter, header text, and value accessor will not persist.

var ganttChart = new ej.gantt.Gantt({
    dataSource: GanttData,
    height: '450px',
    taskFields: {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID',
    },
    columns: [
        { field: 'TaskID', headerText: 'Task ID', textAlign: 'Right', width: 120 },
        { field: 'TaskName', headerText: 'Task Name', width: 150},
        { field: 'StartDate', headerText: 'StartDate', width: 150 },
        { field: 'Duration', headerText: 'Duration', width: 150},
    ],
    enablePersistence: true,
    editSettings: {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true,
        allowTaskbarEditing: true,
        showDeleteConfirmDialog: true
    },
    dataBound: dataBound
});
ganttChart.appendTo('#Gantt');

function dataBound(args) {
    var cloned = this.addOnPersist;
    this.addOnPersist = function (key) {
        key = key.filter(function (item) { return item !== "columns"; });
        return cloned.call(this, key);
    };
}

document.getElementById('add').onclick = function () {
    var obj = { field: "Progress", headerText: 'Progress', width: 100 };
    ganttChart.columns.push(obj);
    ganttChart.treeGrid.refreshColumns();
};

document.getElementById('remove').onclick = function () {
    ganttChart.columns.pop();
    ganttChart.treeGrid.refreshColumns();
};
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Gantt</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Gantt Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
	<link href="https://cdn.syncfusion.com/ej2/32.1.19/material.css" rel="stylesheet" type="text/css">
    
    
	
<script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
       
    
    <div id="container">
        <button id="add">Add columns</button>
        <button id="remove">Remove columns</button>   
        <div id="Gantt"></div>        
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Persist the header template and header Text

By default, the Gantt properties such as column template, header text, header template, column formatter, and value accessor will not persist when enablePersistence is set to true. Because the column template and header text can be customized at the application level.

If you wish to restore all these column properties, then you can achieve it by cloning the gantt’s columns property using JavaScript Object’s assign method and storing this along with the persist data manually. While restoring the settings, this column object must be assigned to the gantt’s columns property to restore the column settings as demonstrated in the following sample.

var ganttChart = new ej.gantt.Gantt({
    dataSource: GanttData,
    height: '450px',
    taskFields: {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID',
    },
    columns: [
        { field: 'TaskID', headerText: 'Task ID', textAlign: 'Right', width: 120 },
        { field: 'TaskName', headerText: 'Task Name', width: 150, headerTemplate: '#customertemplate' },
        { field: 'StartDate', headerText: 'StartDate', width: 150 },
        { field: 'Duration', headerText: 'Duration', width: 150},
        { field: 'Progress', headerText: 'Progress', width: 150 },
    ],
    enablePersistence: true,
    editSettings: {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true,
        allowTaskbarEditing: true,
        showDeleteConfirmDialog: true
    },
});
ganttChart.appendTo('#Gantt');

var savedProperties;
document.getElementById('restore').onclick = function () {
    savedProperties = JSON.parse(ganttChart.getPersistData());
    var gridColumnsState = Object.assign([], ganttChart.ganttColumns);
    savedProperties.columns.forEach(function (col) {
        var headerText = gridColumnsState.find(function (colColumnsState) { return colColumnsState.field === col.field; })['headerText'];
        var colTemplate = gridColumnsState.find(function (colColumnsState) { return colColumnsState.field === col.field; })['template'];
        var headerTemplate = gridColumnsState.find(function (colColumnsState) { return colColumnsState.field === col.field; })['headerTemplate'];
        col.headerText = 'Text Changed';
        col.template = colTemplate;
        col.headerTemplate = headerTemplate;
    });
    console.log(savedProperties);
    ganttChart.treeGrid.setProperties(savedProperties);
};
<!DOCTYPE html>
<html lang="en">
    <head>
        <title>EJ2 Gantt</title>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta name="description" content="Typescript Gantt Controls">
        <meta name="author" content="Syncfusion">
        <link href="index.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/32.1.19/material.css" rel="stylesheet" type="text/css">
        <script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
        <script src="es5-datasource.js" type="text/javascript"></script>
    <script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

    <body>
        <script id="customertemplate" type="text/x-template">
            <span class="e-icons e-header" ></span>
            Task Name
        </script>
        
        <div id="container">
            <button id="restore">Restore</button>
            <div id="Gantt"></div>      
        </div>

        <script>
            var ele = document.getElementById('container');
            if(ele) {
            ele.style.visibility = "visible";
            }   
        </script>
        <script src="index.js" type="text/javascript"></script>
    </body>
</html>

State persistence in Vue Gantt component

25 May 202418 minutes to read

State persistence refers to the Gantt’s state maintained in the browser’s localStorage even if the browser is refreshed or if you move to the next page within the browser.

State persistence stores gantt’s model object in the local storage when the enablePersistence is defined as true.

Get or set localStorage value

If the enablePersistence property is set to true, the gantt property value is saved in the window.localStorage for reference. You can get/set the localStorage value by using the getItem/setItem method in the window.localStorage.

//get the Gantt model.
let value: string = window.localStorage.getItem('ganttGantt'); //"ganttGantt" is component name + component id.
let model: Object = JSON.parse(model);
//set the Gantt model.
window.localStorage.setItem('ganttGantt', JSON.stringify(model)); //"ganttGantt" is component name + component id.

You can refer to our Vue Gantt feature tour page for its groundbreaking feature representations. You can also explore our Vue Gantt example to knows how to present and manipulate data.

Prevent columns from persisting

When the enablePersistence property is set to true, the Gantt properties such as Filtering, Sorting , and Columns will persist. You can use the addOnPersist method to prevent these Gantt properties from persisting.

The following example demonstrates how to prevent Gantt columns from persisting. In the dataBound event of the Gantt, you can override the addOnPersist method and remove the columns from the key list given for persistence.

Note: When the enablePersistence property is set to true, the Gantt features such as column template, column formatter, header text, and value accessor will not persist.

<template>
    <div id="app">
       <button id="add"  @click="clickAdd">Add Columns</button>
       <button id="remove"  @click="clickRemove">Remove Columns</button>
      <br /><br />
        <ejs-gantt ref="gantt" :dataSource='data' :enablePersistence='true' height='230px' id="Gantt" :taskFields = "taskFields" :dataBound='dataBound'>
           <e-columns>
                <e-column field='TaskID' headerText='Task ID' textAlign='Right' width=120></e-column>
                <e-column field='TaskName' headerText='Task Name' width=150></e-column>
                <e-column field='StartDate' headerText='Start Date' width=150 ></e-column>
                <e-column field='Duration' headerText='Duration' width=150 ></e-column>
            </e-columns>
        </ejs-gantt>
    </div>
</template>
<script setup>
import { ref } from 'vue';
import { GanttComponent as EjsGantt, ColumnDirective as EColumn, ColumnsDirective as EColumns } from "@syncfusion/ej2-vue-gantt";
import { projectNewData } from './data-source.js';
const gantt = ref(null);
      const data = projectNewData;
      const taskFields = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            child: 'subtasks'
        };
    const dataBound = function () {
        let cloned =  gantt.value.ej2Instances.addOnPersist;
        gantt.value.ej2Instances.addOnPersist = function (key) {
            key = key.filter((item)  => item !== "columns");
            return cloned.call(this, key);
        };
    }
     const clickAdd = function () {
        let obj = { field: "Progress", headerText: 'Progress', width: 100 };
        gantt.value.ej2Instances.columns.push(obj); //you can add the columns by using the Gantt columns method
        gantt.value.ej2Instances.treeGrid.refreshColumns();
    }
     const clickRemove = function () {
        gantt.value.ej2Instances.columns.pop();
        gantt.value.ej2Instances.treeGrid.refreshColumns();
    }
</script>
<style>
</style>
<template>
    <div id="app">
       <button id="add"  @click="clickAdd">Add Columns</button>
       <button id="remove"  @click="clickRemove">Remove Columns</button>
      <br /><br />
        <ejs-gantt ref="gantt" :dataSource='data' :enablePersistence='true' height='230px' id="Gantt" :taskFields = "taskFields" :dataBound='dataBound'>
           <e-columns>
                <e-column field='TaskID' headerText='Task ID' textAlign='Right' width=120></e-column>
                <e-column field='TaskName' headerText='Task Name' width=150></e-column>
                <e-column field='StartDate' headerText='Start Date' width=150 ></e-column>
                <e-column field='Duration' headerText='Duration' width=150 ></e-column>
            </e-columns>
        </ejs-gantt>
    </div>
</template>
<script>
import { GanttComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-vue-gantt";
import { projectNewData } from './data-source.js';
export default {
name: "App",
components: {
"ejs-gantt":GanttComponent,
"e-columns":ColumnsDirective,
"e-column":ColumnDirective
},
  data() {
    return {
      data: projectNewData,
      taskFields: {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            child: 'subtasks'
        }
    };
  },
  methods: {
    dataBound: function () {
        let cloned =  this.$refs.gantt.ej2Instances.addOnPersist;
        this.$refs.gantt.ej2Instances.addOnPersist = function (key) {
            key = key.filter((item)  => item !== "columns");
            return cloned.call(this, key);
        };
    },
     clickAdd: function () {
        let obj = { field: "Progress", headerText: 'Progress', width: 100 };
        this.$refs.gantt.ej2Instances.columns.push(obj); //you can add the columns by using the Gantt columns method
        this.$refs.gantt.ej2Instances.treeGrid.refreshColumns();
    },
     clickRemove: function () {
        this.$refs.gantt.ej2Instances.columns.pop();
        this.$refs.gantt.ej2Instances.treeGrid.refreshColumns();
    }
  }
}
</script>
<style>
</style>

Persist the header template and header Text

By default, the Gantt properties such as column template, header text, header template, column formatter, and value accessor will not persist when enablePersistence is set to true. Because the column template and header text can be customized at the application level.

If you wish to restore all these column properties, then you can achieve it by cloning the gantt columns property using JavaScript Object’s assign method and storing this along with the persist data manually. While restoring the settings, this column object must be assigned to the gantt’s columns property to restore the column settings as demonstrated in the following sample.

<template>
  <div id="app">
    <button id="restore" @click="clickRestore">Restore</button>
    <br /><br />
    <ejs-gantt ref="gantt" :dataSource='data' :enablePersistence='true' height='230px' id="Gantt"
      :taskFields="taskFields">
      <e-columns>
        <e-column field='TaskID' headerText='Task ID' textAlign='Right' width=120></e-column>
        <e-column field='TaskName' headerText='Task Name' width=150 :headerTemplate="hTemplate"></e-column>
        <e-column field='StartDate' headerText='Start Date' width=150></e-column>
        <e-column field='Duration' headerText='Duration' width=150></e-column>
      </e-columns>
    </ejs-gantt>
  </div>
</template>
  
<script id="customertemplate" type="text/x-template">
<span class="e-icons e-header" ></span>
</script>
<script setup>
import { ref, createApp } from 'vue';
import { GanttComponent as EjsGantt } from "@syncfusion/ej2-vue-gantt";
import { projectNewData } from './data-source.js';
const gantt = ref(null);
const app = createApp();
var headTemplate = app.component("header", {
  template: '<span class="e-icons e-header">Task Name</span>',
  data() {
    return {
      data: {}
    };
  }
});
const data = projectNewData;
const taskFields = {
  id: 'TaskID',
  name: 'TaskName',
  startDate: 'StartDate',
  duration: 'Duration',
  progress: 'Progress',
  child: 'subtasks'
}
const hTemplate = function (e) {
  return {
    template: headTemplate
  };
}
const clickRestore = function () {
  const savedProperties = JSON.parse(gantt.value.ej2Instances.getPersistData());
  const gridColumnsState = [...gantt.value.ej2Instances.ganttColumns];

  savedProperties.columns.forEach(col => {
    const columnState = gridColumnsState.find(colState => colState.field === col.field);
    if (columnState) {
      col.headerText = 'Text Changed';
      col.template = columnState.template;
      col.headerTemplate = columnState.headerTemplate;
    }
  });

  console.log(savedProperties);
  gantt.value.ej2Instances.treeGrid.setProperties(savedProperties);
}
</script>
<style>
.e-column:before {
  content: '\e815';
}

.e-header:before {
  content: '\ea9a';
}
</style>
<template>
  <div id="app">
    <button id="restore" @click="clickRestore">Restore</button>
    <br /><br />
    <ejs-gantt ref="gantt" :dataSource="data" :enablePersistence="true" height="230px" id="Gantt" :taskFields="taskFields">
      <e-columns>
        <e-column field="TaskID" headerText="Task ID" textAlign="Right" width="120"></e-column>
        <e-column field="TaskName" headerText="Task Name" width="150" :headerTemplate="hTemplate"></e-column>
        <e-column field="StartDate" headerText="Start Date" width="150"></e-column>
        <e-column field="Duration" headerText="Duration" width="150"></e-column>
      </e-columns>
    </ejs-gantt>
  </div>
  </template>
  
  <script>
  import { GanttComponent ,ColumnsDirective,ColumnDirective} from "@syncfusion/ej2-vue-gantt";
  import { projectNewData } from './data-source.js';
  import { createApp } from 'vue';
  
  const app = createApp();
  
  const headerTemplate = {
  template: '<span class="e-icons e-header">Task Name</span>',
  };
  
  export default {
  name: "App",
  components: {
    "ejs-gantt": GanttComponent,
    "e-columns":ColumnsDirective,
    "e-column":ColumnDirective,  
  },
  data() {
    return {
      data: projectNewData,
      taskFields: {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        child: 'subtasks'
      },
      hTemplate: headerTemplate,
    };
  },
  methods: {
    clickRestore: function () {
      let savedProperties = JSON.parse(this.$refs.gantt.ej2Instances.getPersistData());
      let gridColumnsState = Object.assign([], this.$refs.gantt.ej2Instances.ganttColumns);
      savedProperties.columns.forEach((col) => {
        let headerText = gridColumnsState.find((colColumnsState) => colColumnsState.field === col.field)['headerText'];
        let colTemplate = gridColumnsState.find((colColumnsState) => colColumnsState.field === col.field)['template'];
        let headerTemplate = gridColumnsState.find((colColumnsState) => colColumnsState.field === col.field)['headerTemplate'];
        col.headerText = 'Text Changed';
        col.template = colTemplate;
        col.headerTemplate = headerTemplate; //likewise you can restore required column properties as per your needs.
      });
      console.log(savedProperties);
      this.$refs.gantt.ej2Instances.treeGrid.setProperties(savedProperties);
    }
  }
  };
  </script>
  
  <style>
  .e-column:before {
  content: '\e815';
  }
  
  .e-header:before {
  content: '\ea9a';
  }
  </style>

State persistence in React Gantt component

2 Feb 202319 minutes to read

State persistence refers to the Gantt’s state maintained in the browser’s localStorage even if the browser is refreshed or if you move to the next page within the browser. State persistence stores gantt’s model object in the local storage when the enablePersistence is defined as true.

Get or set localStorage value

If the enablePersistence property is set to true, the gantt property value is saved in the window.localStorage for reference. You can get/set the localStorage value by using the getItem/setItem method in the window.localStorage.

//get the Gantt model.
let value: string = window.localStorage.getItem('ganttGantt'); //"ganttGantt" is component name + component id.
let model: Object = JSON.parse(model);
//set the Gantt model.
window.localStorage.setItem('ganttGantt', JSON.stringify(model)); //"ganttGantt" is component name + component id.

You can refer to our React Gantt feature tour page for its groundbreaking feature representations. You can also explore our React Gantt example to knows how to present and manipulate data.

Prevent columns from persisting

When the enablePersistence property is set to true, the Gantt properties such as Filtering, Sorting , and Columns will persist. You can use the addOnPersist method to prevent these Gantt properties from persisting.

The following example demonstrates how to prevent Gantt columns from persisting. In the dataBound event of the Gantt, you can override the addOnPersist method and remove the columns from the key list given for persistence.

Note: When the enablePersistence property is set to true, the Gantt features such as column template, column formatter, header text, and value accessor will not persist.

import { GanttComponent,ColumnsDirective,ColumnDirective } from '@syncfusion/ej2-react-gantt';
import { Gantt} from '@syncfusion/ej2-react-gantt';
import * as ReactDOM from 'react-dom';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import * as React from 'react';
import { data } from './datasource';

function App (){
  let ganttInstance;

  function dataBound(){
    let cloned =  ganttInstance.addOnPersist;
    ganttInstance.addOnPersist = function (key) 
    {
      key = key.filter((item)  => item !== "columns");
      return cloned.call(this, key);
    };
  }

  function addColumn(){
    let obj = { field: "Progress", headerText: 'Progress', width: 100 };
    ganttInstance.columns.push(obj); //you can add the columns by using the Gantt columns method
    ganttInstance.treeGrid.refreshColumns();
  }

  function removeColumn(){
  ganttInstance.columns.pop();
  ganttInstance.treeGrid.refreshColumns();
  }
  const taskFields = {
    id: 'TaskId',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'parentId'
  };
  return( <div> 
    <ButtonComponent onClick= { addColumn }>Add Columns</ButtonComponent>
    <ButtonComponent onClick= { removeColumn }>Remove Columns</ButtonComponent>
    <GanttComponent 
      id="Gantt" 
      dataSource={data} 
      enablePersistence={true} 
      dataBound={dataBound} 
      height={430} 
      taskFields={taskFields}
      ref={gantt => ganttInstance = gantt}>
      <ColumnsDirective>
        <ColumnDirective field='TaskId' width='100'/>
        <ColumnDirective field='TaskName' width='100'/>
        <ColumnDirective field='StartDate' width='100'/>
        <ColumnDirective field='Duration' width='100'/>
      </ColumnsDirective>
    </GanttComponent></div>
  )
};
ReactDOM.render(<App />, document.getElementById('root'));
import { GanttComponent,ColumnsDirective,ColumnDirective } from '@syncfusion/ej2-react-gantt';
import { Gantt} from '@syncfusion/ej2-react-gantt';
import * as ReactDOM from 'react-dom';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import * as React from 'react';
import { data } from './datasource';

function App (){
  let ganttInstance: any;

  function dataBound(){
    let cloned =  ganttInstance.addOnPersist;
    ganttInstance.addOnPersist = function (key: any) 
    {
      key = key.filter((item: string)  => item !== "columns");
      return cloned.call(this, key);
    };
  }

  function addColumn(){
    let obj = { field: "Progress", headerText: 'Progress', width: 100 };
    ganttInstance.columns.push(obj as any); //you can add the columns by using the Gantt columns method
    ganttInstance.treeGrid.refreshColumns();
  }

  function removeColumn(){
    ganttInstance.columns.pop();
    ganttInstance.treeGrid.refreshColumns();
  }

  const taskFields: any = {
    id: 'TaskId',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'parentId'
  };
  return( <div> 
    <ButtonComponent onClick= { addColumn }>Add Columns</ButtonComponent>
    <ButtonComponent onClick= { removeColumn }>Remove Columns</ButtonComponent>
    <GanttComponent 
      id="Gantt" 
      dataSource={data} 
      enablePersistence={true} 
      dataBound={dataBound} 
      height={430} 
      taskFields={taskFields}
      ref={gantt => ganttInstance = gantt}>
      <ColumnsDirective>
        <ColumnDirective field='TaskId' width='100'/>
        <ColumnDirective field='TaskName' width='100'/>
        <ColumnDirective field='StartDate' width='100'/>
        <ColumnDirective field='Duration' width='100'/>
      </ColumnsDirective>
    </GanttComponent></div>
  )
};
ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/material.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Persist the header template and header Text

By default, the Gantt properties such as column template, header text, header template, column formatter, and value accessor will not persist when enablePersistence is set to true. Because the column template and header text can be customized at the application level.

If you wish to restore all these column properties, then you can achieve it by cloning the gantt columns property using JavaScript Object’s assign method and storing this along with the persist data manually. While restoring the settings, this column object must be assigned to the gantt’s columns property to restore the column settings as demonstrated in the following sample.

import { ColumnDirective, ColumnsDirective, GanttComponent } from '@syncfusion/ej2-react-gantt';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { Gantt} from '@syncfusion/ej2-react-gantt';
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { data } from './datasource';

function App (){

  let ganttInstance;

  function clickHandler(){
    let savedProperties = JSON.parse(ganttInstance.getPersistData());
    let gridColumnsState = Object.assign([], ganttInstance.ganttColumns);
    savedProperties.columns.forEach((col) => {
      let headerText = gridColumnsState.find((colColumnsState) => colColumnsState.field === col.field)['headerText'];
      let colTemplate = gridColumnsState.find((colColumnsState) => colColumnsState.field === col.field)['template'];
      let headerTemplate = gridColumnsState.find((colColumnsState) => colColumnsState.field === col.field)['headerTemplate'];
      col.headerText = 'Text Changed';
      col.template = colTemplate;
      col.headerTemplate = headerTemplate; //likewise you can restore required column properties as per your wants.
    });
    console.log(savedProperties);
    ganttInstance.treeGrid.setProperties(savedProperties);
  }

  const taskFields = {
    id: 'TaskId',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'parentId'
  };
  const headerTemplate = customerTemplate;

  function customerTemplate(props) {
    return (<div>
      <span className="e-icons e-header" ></span>Task Name
    </div>);
  }
  return( <div> 
    <ButtonComponent onClick= { clickHandler }>Restore</ButtonComponent> 
    <GanttComponent 
      id="Gantt" 
      dataSource={data}
      taskFields={taskFields} 
      enablePersistence={true} 
      height={230}
      ref={gantt => ganttInstance = gantt}>
      <ColumnsDirective>
        <ColumnDirective field='TaskId' width='100' textAlign="Right"/>
        <ColumnDirective field='TaskName' width='100' headerTemplate={headerTemplate}/>
        <ColumnDirective field='StartDate' width='100'/>
        <ColumnDirective field='Duration' width='100'/>
      </ColumnsDirective>
    </GanttComponent></div>
  )
};
ReactDOM.render(<App />, document.getElementById('root'));
import { ColumnDirective, ColumnsDirective, GanttComponent } from '@syncfusion/ej2-react-gantt';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { Gantt} from '@syncfusion/ej2-react-gantt';
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { data } from './datasource';

function App (){

  let  ganttInstance: Gantt | null;
  
  function clickHandler(){
    let savedProperties = JSON.parse(ganttInstance.getPersistData());
    let gridColumnsState = Object.assign([], ganttInstance.ganttColumns);
    savedProperties.columns.forEach((col: {
      field: any;
      headerText: any;
      template: any;
      headerTemplate: any;
    }) => {
      let headerText = gridColumnsState.find((colColumnsState) => colColumnsState.field === col.field)['headerText'];
      let colTemplate = gridColumnsState.find((colColumnsState) => colColumnsState.field === col.field)['template'];
      let headerTemplate = gridColumnsState.find((colColumnsState) => colColumnsState.field === col.field)['headerTemplate'];
      col.headerText = 'Text Changed';
      col.template = colTemplate;
      col.headerTemplate = headerTemplate; //likewise you can restore required column properties as per your wants.
    }
    );
    console.log(savedProperties);
    ganttInstance.treeGrid.setProperties(savedProperties);
  }

  const taskFields: any = {
    id: 'TaskId',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'parentId'
  };

  const headerTemplate: any = customerTemplate;
  
  function customerTemplate(props: any): any {
    return (<div>
      <span className="e-icons e-header" ></span>Task Name
    </div>);
  }
  return( <div> 
    <ButtonComponent onClick= { clickHandler }>Restore</ButtonComponent> 
    <GanttComponent 
      id="Gantt" 
      dataSource={data}
      taskFields={taskFields} 
      enablePersistence={true} 
      height={230}
      ref={gantt => ganttInstance = gantt}
    >
      <ColumnsDirective>
        <ColumnDirective field='TaskId' width='100' textAlign="Right"/>
        <ColumnDirective field='TaskName' width='100' headerTemplate={headerTemplate}/>
        <ColumnDirective field='StartDate' width='100'/>
        <ColumnDirective field='Duration' width='100'/>
      </ColumnsDirective>
    </GanttComponent></div>
  )
};
ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/material.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

State persistence in Angular Gantt component

15 Oct 202524 minutes to read

The Syncfusion® Angular Gantt component supports state management to retain its configuration and data after a browser refresh during the same session.

To enable this, set the enablePersistence property to true. Once enabled, the component saves its state in the browser’s localStorage and restores it automatically after page reloads.

Restore initial Gantt state

The Syncfusion® Angular Gantt component provides options to reset its state, reverting all interactions and configurations to the original setup. This is useful for clearing filters, sorting, and column arrangements, even when enablePersistence is enabled.

Changing component id

To reset the Gantt to its default state, update the component ID. This initializes the component as a new instance, restoring its original configuration.

Here is an example code to change the component id dynamically to restore initial gantt state.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { GanttModule, GanttComponent, SortService, ToolbarService, EditService, FilterService, EditSettingsModel, ToolbarItem } from '@syncfusion/ej2-angular-gantt';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttModule, ButtonModule],
  providers: [ToolbarService, EditService, SortService, FilterService],
  encapsulation: ViewEncapsulation.None,
  template: `
    <button ejs-button style="margin-bottom:20px" id="restore" (click)="clickHandler()">Restore</button>
    <ejs-gantt  #gantt [id]='ganttId' height="430px" [allowSorting] ="true" [allowFiltering]="true"  [editSettings]="editSettings" [toolbar]="toolbar" [dataSource]="data" [taskFields]="taskSettings" [enablePersistence]='true' [splitterSettings]="splitterSettings">
      <e-columns>
        <e-column field="TaskID" width="90" textAlign="Right"></e-column>
        <e-column field="TaskName" width="290"></e-column>
        <e-column field="StartDate" width="390" format="yMd" textAlign="Right"></e-column>
        <e-column field="Duration" width="120" textAlign="Right"></e-column>
        <e-column field="Progress" width="120" textAlign="Right"></e-column>
      </e-columns>
    </ejs-gantt>`
})

export class AppComponent implements OnInit {
  @ViewChild('gantt') public ganttInstance?: GanttComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public splitterSettings: object = { columnIndex: 2 };
  public editSettings?: EditSettingsModel;
  public toolbar?: ToolbarItem[];
  public ganttId?: string = 'TaskDetails'; // Id for the Gantt component.

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.editSettings = {
      allowAdding: true,
      allowEditing: true,
      allowDeleting: true,
      allowTaskbarEditing: true,
      showDeleteConfirmDialog: true
    };
    this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel', 'Search','ExpandAll', 'CollapseAll', 'PrevTimeSpan', 'NextTimeSpan', 'Indent', 'Outdent'];
  }

  public clickHandler(): void {
    this.ganttId = `TaskDetails` + Math.floor(Math.random() * 10);
    location.reload();
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Clearing local storage

Clearing the browser’s local storage associated with the Gantt component removes all persisted data, allowing it to load with its initial settings.

Here is an example code on how to clear local storage to retain its default state.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { GanttModule, GanttComponent, ToolbarService, EditService, FilterService, EditSettingsModel, ToolbarItem } from '@syncfusion/ej2-angular-gantt';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttModule, ButtonModule],
  providers: [ToolbarService, EditService, FilterService],
  encapsulation: ViewEncapsulation.None,
  template: `
    <button ejs-button style="margin-bottom:20px" id="restore" (click)="clickHandler()">Restore</button>
    <ejs-gantt  #gantt id="TaskDetails" height="430px" [allowFiltering]="true"  [editSettings]="editSettings" [toolbar]="toolbar" [dataSource]="data" [taskFields]="taskSettings" [enablePersistence]='true' [splitterSettings]="splitterSettings">
      <e-columns>
        <e-column field="TaskID" width="90" textAlign="Right"></e-column>
        <e-column field="TaskName" width="290"></e-column>
        <e-column field="StartDate" width="390" format="yMd" textAlign="Right"></e-column>
        <e-column field="Duration" width="120" textAlign="Right"></e-column>
        <e-column field="Progress" width="120" textAlign="Right"></e-column>
      </e-columns>
    </ejs-gantt>`
})

export class AppComponent implements OnInit {
  @ViewChild('gantt') public ganttInstance?: GanttComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public splitterSettings: object = { columnIndex: 2 };
  public editSettings?: EditSettingsModel;
  public toolbar?: ToolbarItem[];

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.editSettings = {
      allowAdding: true,
      allowEditing: true,
      allowDeleting: true,
      allowTaskbarEditing: true,
      showDeleteConfirmDialog: true
    };
    this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel', 'ExpandAll', 'CollapseAll', 'PrevTimeSpan', 'NextTimeSpan', 'Indent', 'Outdent'];
  }

  public clickHandler(): void {
    (this.ganttInstance as GanttComponent).enablePersistence = false;
    window.localStorage.setItem("ganttTaskDetails", ""); // Here gantt is component name and TaskDetails is component ID.
    (this.ganttInstance as GanttComponent).destroy();
    location.reload();
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Restore to previous state

The Syncfusion® Angular Gantt component allows saving and restoring its state using local storage, ensuring retention of configurations like column order, sorting, and filtering.

To implement this functionality, extract the current state using getPersistData, store it with setItem, retrieve it via getItem, and apply it using setProperties to restore the saved configuration.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { GanttComponent, GanttModule, EditSettingsModel, ToolbarItem, SortService, ToolbarService, EditService, FilterService } from '@syncfusion/ej2-angular-gantt';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttModule, ButtonModule],
  providers: [ToolbarService, EditService, SortService, FilterService],
  encapsulation: ViewEncapsulation.None,
  template: `
    <button ejs-button class="e-success" style="margin-right: 10px;" (click)="save()">Save</button>
    <button ejs-button class="e-danger" (click)="restore()">Restore</button>
    <div style="margin-top: 20px; margin-bottom:10px; color: green; text-align: center;">
    </div>
    <ejs-gantt #gantt id="TaskDetails" height="430px" [allowSorting]="true" [allowFiltering]="true" [editSettings]="editSettings" [toolbar]="toolbar" [dataSource]="data"
    [taskFields]="taskSettings" [enablePersistence]="true" [splitterSettings]="splitterSettings" [sortSettings]="sortSettings">
      <e-columns>
        <e-column field="TaskID" width="90" textAlign="Right"></e-column>
        <e-column field="TaskName" width="290"></e-column>
        <e-column field="StartDate" width="390" format="yMd" textAlign="Right"></e-column>
        <e-column field="Duration" width="120" textAlign="Right"></e-column>
      </e-columns>
    </ejs-gantt>`
})

export class AppComponent implements OnInit {
  @ViewChild('gantt') public ganttInstance?: GanttComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public splitterSettings: object = { columnIndex: 2 };
  public editSettings?: EditSettingsModel;
  public toolbar?: ToolbarItem[];
  public message?: string;
  public sortSettings?: object;

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.editSettings = {
      allowAdding: true,
      allowEditing: true,
      allowDeleting: true,
      allowTaskbarEditing: true,
      showDeleteConfirmDialog: true
    };
    this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel', 'Search', 'ExpandAll', 'CollapseAll', 'PrevTimeSpan', 'NextTimeSpan', 'Indent', 'Outdent'];
  }

  public save() {
    const persistData = this.ganttInstance?.getPersistData();
    if (persistData) {
      window.localStorage.setItem("ganttTaskDetails", persistData);
      this.message = "Gantt state saved.";
    }
  }

  public restore() {
    const value = window.localStorage.getItem("ganttTaskDetails");
    if (value) {
      const state = JSON.parse(value);
      this.ganttInstance?.treeGrid.setProperties(state);
      this.message = "Previous Gantt state restored.";
    } else {
      this.message = "No saved state found.";
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Get or set localStorage value

When enablePersistence is set to true, the Gantt component state is stored in window.localStorage. The stored data can be retrieved or updated using the getItem and setItem methods available in the browser’s localStorage.

//get the Gantt model.
let value: string = window.localStorage.getItem('ganttGantt'); //"ganttGantt" is component name + component id.
let model: Object = JSON.parse(model);
//set the Gantt model.
window.localStorage.setItem('ganttGantt', JSON.stringify(model)); //"ganttGantt" is component name + component id.

You can refer to our Angular Gantt feature tour page for its groundbreaking feature representations. You can also explore our Angular Gantt example to knows how to present and manipulate data.

Prevent columns from persisting

When enablePersistence is set to true, Gantt properties such as Filtering, Sorting, and Columns are automatically saved.

To prevent specific properties from being persisted, use the addOnPersist method.

When the enablePersistence property is set to true, the Gantt features such as column template, column formatter, header text, and value accessor will not persist.

The example below shows how to prevent Gantt columns from being persisted. In the dataBound event, override the addOnPersist method and remove Columns from the persistence key list.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { GanttComponent, GanttModule, ToolbarService, EditService } from '@syncfusion/ej2-angular-gantt';
import { TaskFieldsModel, ColumnModel } from '@syncfusion/ej2-angular-gantt';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttModule],
  providers: [ToolbarService, EditService],
  encapsulation: ViewEncapsulation.None,
  template: `
    <div style="margin-bottom: 16px;">
      <button ejs-button id="add" style="margin-right: 8px;" (click)="addColumn()">Add Column</button>
      <button ejs-button id="remove" (click)="removeColumn()">Remove Column</button>
    </div>
    <ejs-gantt #gantt id="ganttDefault" height="430px" [dataSource]="data" [taskFields]="taskSettings" [columns]="columns" enablePersistence="true" (dataBound)="onDataBound()">
    </ejs-gantt>`
})

export class AppComponent implements OnInit {
  @ViewChild('gantt') ganttInstance!: GanttComponent;
  public data: object[] = [];
  public taskSettings: TaskFieldsModel = {};
  public columns: ColumnModel[] = [];

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.columns = [
      { field: 'TaskID', headerText: 'Task ID', textAlign: 'Right', width: 120 },
      { field: 'TaskName', headerText: 'Task Name', width: 150 },
      { field: 'StartDate', headerText: 'Start Date', width: 150 },
      { field: 'Duration', headerText: 'Duration', width: 150 },
      { field: 'Progress', headerText: 'Progress', width: 150 }
    ];
  }

  public onDataBound(): void {
    const originalPersist = (this.ganttInstance as any).addOnPersist;
    (this.ganttInstance as any).addOnPersist = (keys: string[]): string[] => {
      const filteredKeys = keys.filter(key => key !== 'columns');
      return originalPersist.call(this.ganttInstance, filteredKeys);
    };
  }

  public addColumn(): void {
    const newColumn : ColumnModel = {
      field: 'Progress',
      headerText: 'Progress',
      width: 100
    };
    (this.ganttInstance.columns as ColumnModel[]).push(newColumn);
    this.ganttInstance.refresh();
  }

  public removeColumn(): void {
    this.ganttInstance.columns.pop();
    this.ganttInstance.refresh();
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Add to persist

Persistence in the Syncfusion® Angular Gantt component enables storing and restoring the component state. It supports preserving column layout, sorting, filtering, and configuration elements such as column templates, header templates, and header text, ensuring consistent behavior across sessions.

Add a new column in persisted columns list

When enablePersistence is set to true in the Syncfusion Gantt component, column configurations are saved automatically. To add a new column to the persisted list, update the column collection using columns.push(), then call the refreshColumns method on the treeGrid object in the Gantt instance to update the UI.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { GanttComponent, GanttModule, ToolbarService, EditService } from '@syncfusion/ej2-angular-gantt';
import { TaskFieldsModel, ColumnModel } from '@syncfusion/ej2-angular-gantt';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttModule],
  providers: [ToolbarService, EditService],
  encapsulation: ViewEncapsulation.None,
  template: `
    <div style="margin-bottom: 16px;">
      <button ejs-button id="add" style="margin-right: 8px;" (click)="addColumn()">Add Column</button>
      <button ejs-button id="remove" (click)="removeColumn()">Remove Column</button>
    </div>
    <ejs-gantt #gantt id="ganttDefault" height="430px" [dataSource]="data" [taskFields]="taskSettings" [columns]="columns" enablePersistence="true" (dataBound)="onDataBound()">
    </ejs-gantt>`
})

export class AppComponent implements OnInit {
  @ViewChild('gantt') ganttInstance!: GanttComponent;
  public data: object[] = [];
  public taskSettings: TaskFieldsModel = {};
  public columns: ColumnModel[] = [];

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.columns = [
      { field: 'TaskID', headerText: 'Task ID', textAlign: 'Right', width: 120 },
      { field: 'TaskName', headerText: 'Task Name', width: 150 },
      { field: 'StartDate', headerText: 'Start Date', width: 150 },
      { field: 'Duration', headerText: 'Duration', width: 150 },
      { field: 'Progress', headerText: 'Progress', width: 150 }
    ];
  }

  public onDataBound(): void {
    const originalPersist = (this.ganttInstance as any).addOnPersist;
    (this.ganttInstance as any).addOnPersist = (keys: string[]): string[] => {
      const filteredKeys = keys.filter(key => key !== 'columns');
      return originalPersist.call(this.ganttInstance, filteredKeys);
    };
  }

  public addColumn(): void {
    const newColumn : ColumnModel = {
      field: 'Progress',
      headerText: 'Progress',
      width: 100
    };
    (this.ganttInstance.columns as ColumnModel[]).push(newColumn);
    this.ganttInstance.refresh();
  }

  public removeColumn(): void {
    this.ganttInstance.columns.pop();
    this.ganttInstance.refresh();
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Persist the header template and header Text

By default, properties such as column template, header text, header template, formatter, and value accessor are not persisted when enablePersistence is set to true, as these are defined at the application level.

To persist these settings, clone the Columns property using Object.assign, store it manually along with the persisted data, and reassign it to the Gantt’s Columns property during restoration.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { GanttModule, GanttComponent, ToolbarService, EditService } from '@syncfusion/ej2-angular-gantt';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [GanttModule , ButtonModule],
  providers: [ToolbarService, EditService],
  encapsulation: ViewEncapsulation.None,
  template: `
    <button ejs-button style="margin-bottom:20px" id="restore" (click)="clickHandler()">Restore</button>
    <ejs-gantt id="ganttDefault" #gantt height="430px" [dataSource]="data" [taskFields]="taskSettings" [enablePersistence]='true' [splitterSettings]="splitterSettings">
      <e-columns>
        <e-column field="TaskID" width="90" textAlign="Right"></e-column>
        <e-column field="TaskName" width="290">
          <ng-template #headerTemplate>
            <div style="width: 20px; height: 20px;">Tasks Name</div>
          </ng-template>
        </e-column>
        <e-column field="StartDate" width="390" format="yMd" textAlign="Right"></e-column>
        <e-column field="Duration" width="120" textAlign="Right"></e-column>
        <e-column field="Progress" width="120" textAlign="Right"></e-column>
      </e-columns>
    </ejs-gantt>`
})

export class AppComponent implements OnInit {
  @ViewChild('gantt') public ganttInstance?: GanttComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public splitterSettings: object = { columnIndex: 2 };

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];

    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
  }

  public clickHandler(): void {
    const savedProperties = JSON.parse((this.ganttInstance as GanttComponent).getPersistData());
    const gridColumnsState = [...(this.ganttInstance as GanttComponent).ganttColumns];
    savedProperties.columns.forEach((col: any) => {
      const state = gridColumnsState.find((c: any) => c.field === col.field);
      if (state) {
        col.headerText = 'Text Changed';
        col.template = state.template;
        col.headerTemplate = state.headerTemplate;
      }
    });
    (this.ganttInstance as GanttComponent).treeGrid.setProperties(savedProperties);
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));